/*
USE [Lotto]
GO



-- Schritt 1:
-- die relevanten Datenstze eines Spieltages in eine eigene Tabelle kopieren
DELETE FROM [Lotto].[Auswertung]
GO



DECLARE @Spieltagsdatum		AS [DATE]
SET		@Spieltagsdatum		= '1955-10-12'

INSERT INTO [Lotto].[Auswertung]
           ([Datum]
           ,[Wochentag]
           ,[Zahl01]
           ,[Zahl02]
           ,[Zahl03]
           ,[Zahl04]
           ,[Zahl05]
           ,[Zahl06]
           ,[Zusatzzahl]
           ,[AnzahlTreffer]
			 ,[Gewinnklasse])
SELECT 
      [Datum]
      , [Wochentag]
      , [Zahl01]
      , [Zahl02]
      , [Zahl03]
      , [Zahl04]
      , [Zahl05]
      , [Zahl06]
      , [Zusatzzahl]
	  , 0
	  , NULL
  FROM [Lotto].[Tipps]
  WHERE [Datum] = @Spieltagsdatum




-- Schritt 2:
-- Trefferanzahl mit +1 updaten, wenn Zahlxx des Tipps eine der 
-- sechs Zielzahlen ist.
UPDATE [Lotto].[Auswertung]
SET [AnzahlTreffer] = [AnzahlTreffer] + 1
FROM [Lotto].[Auswertung] AS [AW]
LEFT JOIN [Lotto].[Ziehungen] AS [ZI] 
	ON [AW].[Datum] = [ZI].[Datum]
	AND [AW].[Datum] = @Spieltagsdatum

WHERE 1 = 1
	AND (
			   [AW].[Zahl01] = [ZI].[Zahl01]
			OR [AW].[Zahl01] = [ZI].[Zahl02]
			OR [AW].[Zahl01] = [ZI].[Zahl03]
			OR [AW].[Zahl01] = [ZI].[Zahl04]
			OR [AW].[Zahl01] = [ZI].[Zahl05]
			OR [AW].[Zahl01] = [ZI].[Zahl06]
		)



UPDATE [Lotto].[Auswertung]
SET [AnzahlTreffer] = [AnzahlTreffer] + 1
FROM [Lotto].[Auswertung] AS [AW]
LEFT JOIN [Lotto].[Ziehungen] AS [ZI] 
	ON [AW].[Datum] = [ZI].[Datum]
	AND [AW].[Datum] = @Spieltagsdatum

WHERE 1 = 1
	AND (
			   [AW].[Zahl02] = [ZI].[Zahl01]
			OR [AW].[Zahl02] = [ZI].[Zahl02]
			OR [AW].[Zahl02] = [ZI].[Zahl03]
			OR [AW].[Zahl02] = [ZI].[Zahl04]
			OR [AW].[Zahl02] = [ZI].[Zahl05]
			OR [AW].[Zahl02] = [ZI].[Zahl06]
		)



UPDATE [Lotto].[Auswertung]
SET [AnzahlTreffer] = [AnzahlTreffer] + 1
FROM [Lotto].[Auswertung] AS [AW]
LEFT JOIN [Lotto].[Ziehungen] AS [ZI] 
	ON [AW].[Datum] = [ZI].[Datum]
	AND [AW].[Datum] = @Spieltagsdatum

WHERE 1 = 1
	AND (
			   [AW].[Zahl03] = [ZI].[Zahl01]
			OR [AW].[Zahl03] = [ZI].[Zahl02]
			OR [AW].[Zahl03] = [ZI].[Zahl03]
			OR [AW].[Zahl03] = [ZI].[Zahl04]
			OR [AW].[Zahl03] = [ZI].[Zahl05]
			OR [AW].[Zahl03] = [ZI].[Zahl06]
		)



UPDATE [Lotto].[Auswertung]
SET [AnzahlTreffer] = [AnzahlTreffer] + 1
FROM [Lotto].[Auswertung] AS [AW]
LEFT JOIN [Lotto].[Ziehungen] AS [ZI] 
	ON [AW].[Datum] = [ZI].[Datum]
	AND [AW].[Datum] = @Spieltagsdatum

WHERE 1 = 1
	AND (
			   [AW].[Zahl04] = [ZI].[Zahl01]
			OR [AW].[Zahl04] = [ZI].[Zahl02]
			OR [AW].[Zahl04] = [ZI].[Zahl03]
			OR [AW].[Zahl04] = [ZI].[Zahl04]
			OR [AW].[Zahl04] = [ZI].[Zahl05]
			OR [AW].[Zahl04] = [ZI].[Zahl06]
		)



UPDATE [Lotto].[Auswertung]
SET [AnzahlTreffer] = [AnzahlTreffer] + 1
FROM [Lotto].[Auswertung] AS [AW]
LEFT JOIN [Lotto].[Ziehungen] AS [ZI] 
	ON [AW].[Datum] = [ZI].[Datum]
	AND [AW].[Datum] = @Spieltagsdatum

WHERE 1 = 1
	AND (
			   [AW].[Zahl05] = [ZI].[Zahl01]
			OR [AW].[Zahl05] = [ZI].[Zahl02]
			OR [AW].[Zahl05] = [ZI].[Zahl03]
			OR [AW].[Zahl05] = [ZI].[Zahl04]
			OR [AW].[Zahl05] = [ZI].[Zahl05]
			OR [AW].[Zahl05] = [ZI].[Zahl06]
		)



UPDATE [Lotto].[Auswertung]
SET [AnzahlTreffer] = [AnzahlTreffer] + 1
FROM [Lotto].[Auswertung] AS [AW]
LEFT JOIN [Lotto].[Ziehungen] AS [ZI] 
	ON [AW].[Datum] = [ZI].[Datum]
	AND [AW].[Datum] = @Spieltagsdatum

WHERE 1 = 1
	AND (
			   [AW].[Zahl06] = [ZI].[Zahl01]
			OR [AW].[Zahl06] = [ZI].[Zahl02]
			OR [AW].[Zahl06] = [ZI].[Zahl03]
			OR [AW].[Zahl06] = [ZI].[Zahl04]
			OR [AW].[Zahl06] = [ZI].[Zahl05]
			OR [AW].[Zahl06] = [ZI].[Zahl06]
		)



UPDATE [Lotto].[Auswertung]
SET [Gewinnklasse] = 'NIETE'
WHERE [AnzahlTreffer] <= 1



UPDATE [Lotto].[Auswertung]
SET [Gewinnklasse] = 'zwei Richtige mit Zusatzzahl'
WHERE 1 = 1
	AND [AnzahlTreffer] = 2 
	AND 
		(
			SELECT TOP(1) [Zusatzzahl] 
			FROM [Lotto].[Ziehungen] AS [ZI] 
			WHERE [ZI].[Datum] = @Spieltagsdatum
		) = [Zusatzzahl]


UPDATE [Lotto].[Auswertung]
SET [Gewinnklasse] = 'NIETE'
WHERE 1 = 1
	AND [AnzahlTreffer] = 2 
	AND 
		(
			SELECT TOP(1) [Zusatzzahl] 
			FROM [Lotto].[Ziehungen] AS [ZI] 
			WHERE [ZI].[Datum] = @Spieltagsdatum
		) <> [Zusatzzahl]



UPDATE [Lotto].[Auswertung]
SET [Gewinnklasse] = 'drei Richtige ohne Zusatzzahl'
WHERE 1 = 1
	AND [AnzahlTreffer] = 3 
	AND 
		(
			SELECT TOP(1) [Zusatzzahl] 
			FROM [Lotto].[Ziehungen] AS [ZI] 
			WHERE [ZI].[Datum] = @Spieltagsdatum
		) <> [Zusatzzahl]

UPDATE [Lotto].[Auswertung]
SET [Gewinnklasse] = 'drei Richtige mit Zusatzzahl'
WHERE 1 = 1
	AND [AnzahlTreffer] = 3 
	AND 
		(
			SELECT TOP(1) [Zusatzzahl] 
			FROM [Lotto].[Ziehungen] AS [ZI] 
			WHERE [ZI].[Datum] = @Spieltagsdatum
		) = [Zusatzzahl]






UPDATE [Lotto].[Auswertung]
SET [Gewinnklasse] = 'vier Richtige ohne Zusatzzahl'
WHERE 1 = 1
	AND [AnzahlTreffer] = 4 
	AND 
		(
			SELECT TOP(1) [Zusatzzahl] 
			FROM [Lotto].[Ziehungen] AS [ZI] 
			WHERE [ZI].[Datum] = @Spieltagsdatum
		) <> [Zusatzzahl]

UPDATE [Lotto].[Auswertung]
SET [Gewinnklasse] = 'vier Richtige mit Zusatzzahl'
WHERE 1 = 1
	AND [AnzahlTreffer] = 4 
	AND 
		(
			SELECT TOP(1) [Zusatzzahl] 
			FROM [Lotto].[Ziehungen] AS [ZI] 
			WHERE [ZI].[Datum] = @Spieltagsdatum
		) = [Zusatzzahl]






UPDATE [Lotto].[Auswertung]
SET [Gewinnklasse] = 'fnf Richtige ohne Zusatzzahl'
WHERE 1 = 1
	AND [AnzahlTreffer] = 5 
	AND 
		(
			SELECT TOP(1) [Zusatzzahl] 
			FROM [Lotto].[Ziehungen] AS [ZI] 
			WHERE [ZI].[Datum] = @Spieltagsdatum
		) <> [Zusatzzahl]

UPDATE [Lotto].[Auswertung]
SET [Gewinnklasse] = 'fnf Richtige mit Zusatzzahl'
WHERE 1 = 1
	AND [AnzahlTreffer] = 5 
	AND 
		(
			SELECT TOP(1) [Zusatzzahl] 
			FROM [Lotto].[Ziehungen] AS [ZI] 
			WHERE [ZI].[Datum] = @Spieltagsdatum
		) = [Zusatzzahl]






UPDATE [Lotto].[Auswertung]
SET [Gewinnklasse] = 'sechs Richtige ohne Zusatzzahl'
WHERE 1 = 1
	AND [AnzahlTreffer] = 6 
	AND 
		(
			SELECT TOP(1) [Zusatzzahl] 
			FROM [Lotto].[Ziehungen] AS [ZI] 
			WHERE [ZI].[Datum] = @Spieltagsdatum
		) <> [Zusatzzahl]

UPDATE [Lotto].[Auswertung]
SET [Gewinnklasse] = 'sechs Richtige mit Zusatzzahl'
WHERE 1 = 1
	AND [AnzahlTreffer] = 6 
	AND 
		(
			SELECT TOP(1) [Zusatzzahl] 
			FROM [Lotto].[Ziehungen] AS [ZI] 
			WHERE [ZI].[Datum] = @Spieltagsdatum
		) = [Zusatzzahl]




-- jeder abgegeben Tipp kostet einen Spieler 1,20 uro
-- von allen Einnahmen behlt der Veranstalter 50%, der Rest wird 
-- nach folgendem Schlssel wieder ausgespielt. Dabei gibt es 
-- fr eine Gewinnstufe fixe Betrge, fr alle anderen Gewinnstufen
-- feste Prozentstze. Alle Gewinner einer Stufe teilen
-- sich den Gewinn fr diese Stufe. Spieler gewinnen nur in der fr 
-- sie hchten Stufe. Sollte eine Gewinnstufe keinen Sieger haben, wird 
-- der Gewinnbetrag der nchsten Ziehung zugeschlagen.
*/

DECLARE @AnzahlTippreihen		AS [INTEGER]
DECLARE @Gesamteinnahme			AS [MONEY]
DECLARE @GesamtGewinnNutzbar	AS [MONEY]
DECLARE @Gesamteinnahme6RpZ		AS [MONEY]
DECLARE @GesamtGewinn6RpZ		AS [MONEY]
DECLARE @EinzelGewinn6RpZ		AS [MONEY]
DECLARE @AnzahlGewinner6RpZ		AS [INTEGER]
DECLARE @AnzahlGewinner2RpZ		AS [INTEGER]
DECLARE @Restgeld				AS [MONEY]
DECLARE @AnzahlGewinner3RoZ		AS [INTEGER]
DECLARE @AnzahlGewinner3RmZ		AS [INTEGER]
DECLARE @AnzahlGewinner4RoZ		AS [INTEGER]
DECLARE @AnzahlGewinner4RmZ		AS [INTEGER]
DECLARE @AnzahlGewinner5RoZ		AS [INTEGER]
DECLARE @AnzahlGewinner5RmZ		AS [INTEGER]
DECLARE @AnzahlGewinner6RoZ		AS [INTEGER]

SET @AnzahlTippreihen		= (SELECT COUNT(*) FROM [Lotto].[Auswertung])
SET @Gesamteinnahme			= 1.2 * @AnzahlTippreihen
SET @GesamtGewinnNutzbar	= @Gesamteinnahme / 2
SET @Gesamteinnahme6RpZ		= @Gesamteinnahme / 100 * 15
SET @AnzahlGewinner6RpZ		= (SELECT COUNT(*) FROM [Lotto].[Auswertung] WHERE [Gewinnklasse] = 'sechs Richtige mit Zusatzzahl')
SET @AnzahlGewinner2RpZ		= (SELECT COUNT(*) FROM [Lotto].[Auswertung] WHERE [Gewinnklasse] = 'zwei Richtige mit Zusatzzahl')
SET @Restgeld				= @GesamtGewinnNutzbar 
								- CASE @AnzahlGewinner6RpZ WHEN 0 THEN 0 ELSE @GesamtGewinnNutzbar / @AnzahlGewinner6RpZ END
								- CASE @AnzahlGewinner2RpZ WHEN 0 THEN 0 ELSE 6 * @AnzahlGewinner2RpZ END
SET @AnzahlGewinner3RoZ		= (SELECT COUNT(*) FROM [Lotto].[Auswertung] WHERE [Gewinnklasse] = 'drei Richtige ohne Zusatzzahl')
SET @AnzahlGewinner3RmZ		= (SELECT COUNT(*) FROM [Lotto].[Auswertung] WHERE [Gewinnklasse] = 'drei Richtige mit Zusatzzahl')
SET @AnzahlGewinner4RoZ		= (SELECT COUNT(*) FROM [Lotto].[Auswertung] WHERE [Gewinnklasse] = 'vier Richtige ohne Zusatzzahl')
SET @AnzahlGewinner4RmZ		= (SELECT COUNT(*) FROM [Lotto].[Auswertung] WHERE [Gewinnklasse] = 'vier Richtige mit Zusatzzahl')
SET @AnzahlGewinner5RoZ		= (SELECT COUNT(*) FROM [Lotto].[Auswertung] WHERE [Gewinnklasse] = 'fnf Richtige ohne Zusatzzahl')
SET @AnzahlGewinner5RmZ		= (SELECT COUNT(*) FROM [Lotto].[Auswertung] WHERE [Gewinnklasse] = 'fnf Richtige mit Zusatzzahl')
SET @AnzahlGewinner6RoZ		= (SELECT COUNT(*) FROM [Lotto].[Auswertung] WHERE [Gewinnklasse] = 'sechs Richtige ohne Zusatzzahl')

SELECT 
	  'Jede abgegeben Tippreihe ist 1,20 Euro wert:'								AS [Bemerkung]
	, CONVERT(NVARCHAR(MAX), @AnzahlTippreihen)										AS [Menge]
	, @Gesamteinnahme																AS [Betrag]
UNION ALL
SELECT 
	  'Der nutzbare Gesamtgewinnbetrag (der Veranstalter darf 50% behalten): '
	, '50% von ' + CONVERT(NVARCHAR(MAX), @AnzahlTippreihen)	
	, @GesamtGewinnNutzbar														
UNION ALL
SELECT 
	  'Alle Gewinner der Klasse "6 Richtige mit Zusatzzahl" teilen sich 15% (' + CONVERT(NVARCHAr(MAX), @Gesamteinnahme6RpZ) + ') des Potts '
	, CASE @AnzahlGewinner6RpZ WHEN 0 THEN '0 Gewinner' ELSE CONVERT(NVARCHAR(MAX), @AnzahlGewinner6RpZ) + ' Gewinner zu ' + CONVERT(NVARCHAR(MAX), (@GesamtGewinnNutzbar / 100 * 15) / @AnzahlGewinner6RpZ) END
	, CASE @AnzahlGewinner6RpZ WHEN 0 THEN 0 ELSE @GesamtGewinnNutzbar / @AnzahlGewinner6RpZ END
UNION ALL
SELECT 
	  'Alle Gewinner der Klasse "2 Richtige mit Zusatzzahl" bekommen einen Fixbetrag'
	, CONVERT(NVARCHAR(MAX), @AnzahlGewinner2RpZ)	+ ' Gewinner zu je 6.00 Euro'
	, CASE @AnzahlGewinner2RpZ WHEN 0 THEN 0 ELSE 6 * @AnzahlGewinner2RpZ END
UNION ALL
SELECT 
	  '----------- das jetzt noch brig gebliebene Geld wird anteilig auf die Gewinnklassen verteilt'
	, 'Restgeld:'	
	, @Restgeld
UNION ALL
SELECT 
	  'Alle Gewinner der Klasse "3 Richtige ohne Zusatzzahl" bekommen 41,1% des Restgeldes'
	, CASE @AnzahlGewinner3RoZ WHEN 0 THEN '0 Gewinner' ELSE CONVERT(NVARCHAR(MAX), @AnzahlGewinner3RoZ) + ' Gewinner zu je ' + CONVERT(NVARCHAR(MAX), CONVERT(MONEY, (@Restgeld/100*41.1) / @AnzahlGewinner3RoZ)) + ' Euro' END
	, CASE @AnzahlGewinner3RoZ WHEN 0 THEN 0 ELSE ROUND(CONVERT(MONEY, (@Restgeld / 100 * 41.1)),2) END
UNION ALL
SELECT 
	  'Alle Gewinner der Klasse "3 Richtige mit Zusatzzahl" bekommen 8,7% des Restgeldes'
	, CASE @AnzahlGewinner3RmZ WHEN 0 THEN '0 Gewinner' ELSE CONVERT(NVARCHAR(MAX), @AnzahlGewinner3RmZ) + ' Gewinner zu je ' + CONVERT(NVARCHAR(MAX), CONVERT(MONEY, (@Restgeld/100*8.7) / @AnzahlGewinner3RmZ)) + ' Euro' END
	, CASE @AnzahlGewinner3RmZ WHEN 0 THEN 0 ELSE ROUND(CONVERT(MONEY, (@Restgeld / 100 * 8.7)),2) END
UNION ALL
SELECT 
	  'Alle Gewinner der Klasse "4 Richtige ohne Zusatzzahl" bekommen 10,2% des Restgeldes'
	, CASE @AnzahlGewinner4RoZ WHEN 0 THEN '0 Gewinner' ELSE CONVERT(NVARCHAR(MAX), @AnzahlGewinner4RoZ) + ' Gewinner zu je ' + CONVERT(NVARCHAR(MAX), CONVERT(MONEY, (@Restgeld/100*10.2) / @AnzahlGewinner4RoZ)) + ' Euro' END
	, CASE @AnzahlGewinner4RoZ WHEN 0 THEN 0 ELSE ROUND(CONVERT(MONEY, (@Restgeld / 100 * 10.2)),2) END
UNION ALL
SELECT 
	  'Alle Gewinner der Klasse "4 Richtige mit Zusatzzahl" bekommen 4,3% des Restgeldes'
	, CASE @AnzahlGewinner4RmZ WHEN 0 THEN '0 Gewinner' ELSE CONVERT(NVARCHAR(MAX), @AnzahlGewinner4RmZ) + ' Gewinner zu je ' + CONVERT(NVARCHAR(MAX), CONVERT(MONEY, (@Restgeld/100*4.3) / @AnzahlGewinner4RmZ)) + ' Euro' END
	, CASE @AnzahlGewinner4RmZ WHEN 0 THEN 0 ELSE ROUND(CONVERT(MONEY, (@Restgeld / 100 * 4.3)), 2) END
UNION ALL
SELECT 
	  'Alle Gewinner der Klasse "5 Richtige ohne Zusatzzahl" bekommen 15,5% des Restgeldes'
	, CASE @AnzahlGewinner5RoZ WHEN 0 THEN '0 Gewinner' ELSE CONVERT(NVARCHAR(MAX), @AnzahlGewinner5RoZ) + ' Gewinner zu je ' + CONVERT(NVARCHAR(MAX), CONVERT(MONEY, (@Restgeld/100*15.5) / @AnzahlGewinner5RoZ)) + ' Euro' END
	, CASE @AnzahlGewinner5RoZ WHEN 0 THEN 0 ELSE ROUND(CONVERT(MONEY, (@Restgeld / 100 * 15.5)), 2) END
UNION ALL
SELECT 
	  'Alle Gewinner der Klasse "5 Richtige mit Zusatzzahl" bekommen 5,2% des Restgeldes'
	, CASE @AnzahlGewinner5RmZ WHEN 0 THEN '0 Gewinner' ELSE CONVERT(NVARCHAR(MAX), @AnzahlGewinner5RmZ) + ' Gewinner zu je ' + CONVERT(NVARCHAR(MAX), CONVERT(MONEY, (@Restgeld/100*5.2) / @AnzahlGewinner5RmZ)) + ' Euro' END
	, CASE @AnzahlGewinner5RmZ WHEN 0 THEN 0 ELSE ROUND(CONVERT(MONEY, (@Restgeld / 100 * 5.2)), 2) END
UNION ALL
SELECT 
	  'Alle Gewinner der Klasse "6 Richtige ohne Zusatzzahl" bekommen 15,0% des Restgeldes'
	, CASE @AnzahlGewinner6RoZ WHEN 0 THEN '0 Gewinner' ELSE CONVERT(NVARCHAR(MAX), @AnzahlGewinner6RoZ) + ' Gewinner zu je ' + CONVERT(NVARCHAR(MAX), CONVERT(MONEY, (@Restgeld/100*15.0) / @AnzahlGewinner6RoZ)) + ' Euro' END
	, CASE @AnzahlGewinner6RoZ WHEN 0 THEN 0 ELSE  ROUND(CONVERT(MONEY, (@Restgeld / 100 * 15)), 2) END




/*
INSERT INTO [Lotto].[Gewinnplan]
           ( [Datum], [Wochentag], [Zahl01], [Zahl02], [Zahl03], [Zahl04], [Zahl05], [Zahl06]
		   , [Zusatzzahl], [AnzahlTreffer], [Gewinnklasse], [Gewinnhoehe])
	(SELECt [Datum], [Wochentag], [Zahl01], [Zahl02], [Zahl03], [Zahl04], [Zahl05], [Zahl06]
		   , [Zusatzzahl], [AnzahlTreffer], [Gewinnklasse], @Gesamteinnahme 
	FROM [Lotto].[Auswertung] WHERE [Gewinnklasse] = 'sechs Richtige mit Zusatzzahl')
*/
